export declare class Heap<T> {
    /**
     * 定义一个存储数据的内存空间
     */
    private _data;
    /**
     * 比较函数
     */
    private _compare;
    get count(): number;
    constructor(...initElements: T[]);
    private _selfCompare;
    /**
     * 设置比较函数
     * @param {(compareVal, currentVal) => boolean} compareFunc
     */
    setCompare(compareFunc: (compareVal: T, currentVal: T) => boolean): void;
    /**
     * 获取堆顶的元素
     */
    protected getTop(): T;
    /**
     * 按断堆是否是空
     */
    isEmpty(): boolean;
    /**
     * 向堆中插入一个合法值
     * @param  val
     */
    insertQueue(val: T): void;
    /**
     * 获取堆中的最值元素
     * @returns
     */
    deleteTop(): T;
    /**
     * 下滤：将堆中以堆data[p]为根的子堆调整为最小堆
     * @param  p 根节点索引
     */
    private percDown;
    /**
     * 构建最小堆
     */
    buildHeap(): void;
    protected writeIntoClipboard(): void;
}
